Index: issm/trunk/src/m/classes/hydrologytws.m
===================================================================
--- issm/trunk/src/m/classes/hydrologytws.m	(revision 26744)
+++ issm/trunk/src/m/classes/hydrologytws.m	(revision 26744)
@@ -0,0 +1,63 @@
+%HYDROLOGYTWS class definition
+%
+%   Usage:
+%      hydrologytws=hydrologytws();
+
+classdef hydrologytws
+	properties (SetAccess=public) 
+		spcwatercolumn     = NaN;
+		requested_outputs  = {};
+	end
+	methods
+		function self = extrude(self,md) % {{{
+		end % }}}
+		function self = hydrologytws(varargin) % {{{
+			switch nargin
+				case 0
+					self=setdefaultparameters(self);
+				case 1
+					self=structtoobj(self,varargin{1});
+				otherwise
+					error('constructor not supported');
+			end
+		end % }}}
+		function list = defaultoutputs(self,md) % {{{
+			list = {''};
+		end % }}}
+
+		function self = setdefaultparameters(self) % {{{
+			self.requested_outputs = {'default'};
+		end % }}}
+		function md = checkconsistency(self,md,solution,analyses) % {{{
+
+			%Early return
+			if ~ismember('HydrologyTwsAnalysis',analyses)
+				return;
+			end
+			md = checkfield(md,'fieldname','hydrology.spcwatercolumn','Inf',1,'timeseries',1);
+		end % }}}
+		function disp(self) % {{{
+			disp(sprintf('   hydrologytws solution parameters:'));
+			fielddisplay(self,'spcwatercolumn','water thickness constraints (NaN means no constraint) [m]');
+			fielddisplay(self,'requested_outputs','additional outputs requested');
+
+		end % }}}
+		function marshall(self,prefix,md,fid) % {{{
+			WriteData(fid,prefix,'name','md.hydrology.model','data',2,'format','Integer');
+			WriteData(fid,prefix,'object',self,'fieldname','spcwatercolumn','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+			outputs = self.requested_outputs;
+			pos  = find(ismember(outputs,'default'));
+			if ~isempty(pos),
+				outputs(pos) = [];  %remove 'default' from outputs
+				outputs      = [outputs defaultoutputs(self,md)]; %add defaults
+			end
+			WriteData(fid,prefix,'data',outputs,'name','md.hydrology.requested_outputs','format','StringArray');
+		end % }}}
+		function savemodeljs(self,fid,modelname) % {{{
+
+			writejs1Darray(fid,[modelname '.hydrology.spcwatercolumn'],self.spcwatercolumn);
+
+		end % }}}
+	end
+end
+
Index: issm/trunk/src/m/classes/hydrologytws.py
===================================================================
--- issm/trunk/src/m/classes/hydrologytws.py	(revision 26744)
+++ issm/trunk/src/m/classes/hydrologytws.py	(revision 26744)
@@ -0,0 +1,64 @@
+import numpy as np
+
+from structtoobj import structtoobj
+
+class hydrologytws(object):
+    """HYDROLOGYTWS class definition
+
+    Usage:
+        hydrologytws = hydrologytws()
+    """
+
+    def __init__(self):  # {{{
+        self.spcwatercolumn = np.nan
+        self.requested_outputs = np.nan
+
+        nargs = len(args)
+        if nargs == 0:
+            self.setdefaultparameters()
+        elif nargs == 1:
+            self = structtoobj(self, args[0])
+        else:
+            raise RuntimeError('constructor not supported')
+    #}}}
+
+    def __repr__(self):  # {{{
+        s = '   hydrologytws solution parameters:\n'
+        s += '{}\n'.format(fielddisplay(self, 'spcwatercolumn', 'water thickness constraints (NaN means no constraint) [m]'))
+        s += '{}\n'.format(fielddisplay(self, 'requested_outputs', 'additional outputs requested'))
+        return s
+    #}}}
+
+    def defaultoutputs(self, md): # {{{
+        return ['']
+    #}}}
+
+    def setdefaultparameters(self):  # {{{
+        self.requested_outputs = ['defualt']
+        return self
+    #}}}
+
+    def extrude(self, md):  # {{{
+        return self
+    #}}}
+
+    def checkconsistency(self, md, solution, analyses):  # {{{
+        # Early return
+        if 'HydrologyTwsAnalysis' not in analyses:
+            return
+        md = checkfield(md, 'fieldname', 'hydrology.spcwatercolumn', 'Inf', 1, 'timeseries', 1)
+    #}}}
+
+    def marshall(self, prefix, md, fid):  # {{{
+        WriteData(fid, prefix, 'name', 'md.hydrology.model', 'data', 2, 'format', 'Integer')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'spcwatercolumn', 'format', 'DoubleMat', 'mattype', 1, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', md.constants.yts)
+        outputs = self.requested_outputs
+        pos  = find(ismember(outputs,'default'))
+        if not len(pos),
+            outputs[pos] = [];  # remove 'default' from outputs
+            outputs.extend(defaultoutputs(self, md)) # add defaults
+        end
+        WriteData(fid, prefix, 'data', outputs, 'name', 'md.hydrology.requested_outputs', 'format', 'StringArray')
+    # }}}
+
+
Index: issm/trunk/src/m/classes/initialization.js
===================================================================
--- issm/trunk/src/m/classes/initialization.js	(revision 25994)
+++ issm/trunk/src/m/classes/initialization.js	(revision 26744)
@@ -17,9 +17,16 @@
 		fielddisplay(this,'pressure','pressure field [Pa]');
 		fielddisplay(this,'temperature','temperature [K]');
+		fielddisplay(this,'enthalpy','enthalpy [J]');
 		fielddisplay(this,'waterfraction','fraction of water in the ice');
 		fielddisplay(this,'sediment_head','sediment water head of subglacial system [m]');
 		fielddisplay(this,'epl_head','epl water head of subglacial system [m]');
 		fielddisplay(this,'epl_thickness','epl layer thickness [m]');
-		fielddisplay(this,'watercolumn','thickness of subglacial water [m]');
+		fielddisplay(this,'watercolumn','subglacial water sheet thickness (for Shreve and GlaDS) [m]');
+		fielddisplay(this,'hydraulic_potential','Hydraulic potential (for GlaDS) [Pa]');
+		fielddisplay(this,'channelarea','subglacial water channel area (for GlaDS) [m2]');
+		fielddisplay(this,'sample','Realization of a Gaussian random field');
+		fielddisplay(this,'bottompressure','Bottom pressures');
+		fielddisplay(this,'dsl','Dynamic sea level.');
+		fielddisplay(this,'str','Steric sea level.');
 
 	}// }}}
@@ -51,4 +58,11 @@
 				checkfield(md,'fieldname','initialization.vy','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices, 1]);
 			}
+			if(ArrayAnyEqual(ArrayIsMember('OceantransportAnalysis',analyses),1)){
+				if (strcmp(solution,'TransientSolution') && md.transient.isslc && md.transient.isoceantransport) {
+					checkfield(md,'fieldname','initialization.bottompressure','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices, 1]);
+					checkfield(md,'fieldname','initialization.dsl','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices, 1]);
+					checkfield(md,'fieldname','initialization.str','NaN',1,'Inf',1,'size',[1, 1]);
+				}
+			}
 			if(ArrayAnyEqual(ArrayIsMember('BalancethicknessSolution',analyses),1) & (solution=='BalancethicknessSolution')){
 				checkfield(md,'fieldname','initialization.vx','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices, 1]);
@@ -65,28 +79,45 @@
 				}
 			}
-			if(ArrayAnyEqual(ArrayIsMember('ThermalAnalysis',analyses),1)){
+			if ((ArrayAnyEqual(ArrayIsMember('ThermalAnalysis',analyses),1)) && !strcmp(solution,'TransientSolution') && md.transient.isthermal == 0){
 				checkfield(md,'fieldname','initialization.vx','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices, 1]);
 				checkfield(md,'fieldname','initialization.vy','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices, 1]);
-				if (md.mesh.dimension() == 3){
-					checkfield(md,'fieldname','initialization.vz','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices ,1]);
-				}
-				checkfield(md,'fieldname','initialization.pressure','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices ,1]);
-				checkfield(md,'fieldname','initialization.temperature','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices ,1]);
-			}
-			if( ArrayAnyEqual(ArrayIsMember('EnthalpyAnalysis',analyses),1) & md.thermal.isenthalpy){
-				checkfield(md,'fieldname','initialization.waterfraction','>=',0,'size',[md.mesh.numberofvertices, 1]);
-				checkfield(md,'fieldname','initialization.watercolumn'  ,'>=',0,'size',[md.mesh.numberofvertices, 1]);
-			}
-			if(ArrayAnyEqual(ArrayIsMember('HydrologyShreveAnalysis',analyses),1)){
+				if (md.mesh.dimension()==3) {
+					checkfield(md,'fieldname','initialization.vz','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices, 1]);
+				}
+				checkfield(md,'fieldname','initialization.pressure','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices, 1]);
+				checkfield(md,'fieldname','initialization.temperature','NaN',1,'Inf',1,'size','universal');
+			}
+			if (ArrayAnyEqual(ArrayIsMember('EnthalpyAnalysis',analyses),1) && md.thermal.isenthalpy){
+				checkfield(md,'fieldname','initialization.waterfraction','>=',0,'size','universal');
+				checkfield(md,'fieldname','initialization.watercolumn'  ,'>=',0,'size','universal');
+			}
+			if (ArrayAnyEqual(ArrayIsMember('HydrologyShreveAnalysis',analyses),1)){
 				if (md.hydrology.type() == 'hydrologyshreve'){
 					checkfield(md,'fieldname','initialization.watercolumn','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices ,1]);
 				}
 			}
-			if(ArrayAnyEqual(ArrayIsMember('HydrologyDCInefficientAnalysis',analyses),1)){
+			if (ArrayAnyEqual(ArrayIsMember('HydrologyTwsAnalysis',analyses),1)){
+				if (md.hydrology.type() == 'hydrologytws'){
+					checkfield(md,'fieldname','initialization.watercolumn','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices ,1]);
+				}
+			}
+			if (ArrayAnyEqual(ArrayIsMember('SealevelchangeAnalysis',analyses),1)){
+				if (strcmp(solution,'TransientSolution') && md.transient.isslc) {
+					checkfield(md,'fieldname','initialization.sealevel','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices, 1]);
+				}
+			}
+			if (ArrayAnyEqual(ArrayIsMember('HydrologyGlaDSAnalysis',analyses),1)){
+				if (md.hydrology.type() == 'hydrologyglads'){
+					checkfield(md,'fieldname','initialization.watercolumn','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices, 1]);
+					checkfield(md,'fieldname','initialization.hydraulic_potential','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices, 1]);
+					checkfield(md,'fieldname','initialization.channelarea','NaN',1,'Inf',1,'>=',0,'size',[md.mesh.numberofedges, 1]);
+				}
+			}
+			if (ArrayAnyEqual(ArrayIsMember('HydrologyDCInefficientAnalysis',analyses),1)){
 				if (md.hydrology.type() == 'hydrologydc'){
 					checkfield(md,'fieldname','initialization.sediment_head','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices, 1]);
 				}
 			}
-			if(ArrayAnyEqual(ArrayIsMember('HydrologyDCEfficientAnalysis',analyses),1)){
+			if (ArrayAnyEqual(ArrayIsMember('HydrologyDCEfficientAnalysis',analyses),1)){
 				if (md.hydrology.type() == 'hydrologydc'){
 					if (md.hydrology.isefficientlayer==1){
@@ -96,4 +127,9 @@
 				}
 			}
+			if (ArrayAnyEqual(ArrayIsMember('SamplingAnalysis',analyses),1) && !strcmp(solution,'TransientSolution')&& md.transient.issampling == 0){
+				if (!isNaN(md.initialization.sample)) {
+					checkfield(md,'fieldname','initialization.sample','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices, 1]);
+				}
+			}
 		} //}}}
 		this.marshall=function(md,prefix,fid) { //{{{
@@ -105,4 +141,8 @@
 			WriteData(fid,prefix,'object',this,'fieldname','vz','format','DoubleMat','mattype',1,'scale',1./yts);
 			WriteData(fid,prefix,'object',this,'fieldname','pressure','format','DoubleMat','mattype',1);
+			WriteData(fid,prefix,'object',this,'fieldname','sealevel','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+			WriteData(fid,prefix,'object',this,'fieldname','bottompressure','format','DoubleMat','mattype',1);
+			WriteData(fid,prefix,'object',this,'fieldname','str','format','DoubleMat','mattype',1);
+			WriteData(fid,prefix,'object',this,'fieldname','dsl','format','DoubleMat','mattype',1);
 			WriteData(fid,prefix,'object',this,'fieldname','temperature','format','DoubleMat','mattype',1);
 			WriteData(fid,prefix,'object',this,'fieldname','waterfraction','format','DoubleMat','mattype',1);
@@ -111,13 +151,20 @@
 			WriteData(fid,prefix,'object',this,'fieldname','epl_thickness','format','DoubleMat','mattype',1);
 			WriteData(fid,prefix,'object',this,'fieldname','watercolumn','format','DoubleMat','mattype',1);
+			WriteData(fid,prefix,'object',this,'fieldname','channelarea','format','DoubleMat','mattype',1);
+			WriteData(fid,prefix,'object',this,'fieldname','hydraulic_potential','format','DoubleMat','mattype',1);
+			WriteData(fid,prefix,'object',this,'fieldname','sample','format','DoubleMat','mattype',1);
 
 			if (md.thermal.isenthalpy){
-				tpmp=NewArrayFill(md.mesh.numberofvertices,0);
-				for (var i=0;i<md.mesh.numberofvertices;i++) tpmp[i]= md.materials.meltingpoint - md.materials.beta*md.initialization.pressure[i];
-				enthalpy=NewArrayFill(md.mesh.numberofvertices,0); 
-				for (var i=0;i<md.mesh.numberofvertices;i++)enthalpy[i] = md.materials.heatcapacity*(md.initialization.temperature[i]-md.constants.referencetemperature);
-				
-				for (var i=0;i<md.mesh.numberofvertices;i++)if(md.initialization.temperature[i]>=tpmp[i]){
-					enthalpy[i] = md.materials.heatcapacity*(tpmp[i] - md.constants.referencetemperature) + md.materials.latentheat*md.initialization.waterfraction[i];
+				let enthalpy;
+				if (isNaN(self.enthalpy) && this.enthalpy.length <= 1) {
+					tpmp=NewArrayFill(md.mesh.numberofvertices,0);
+					for (var i=0;i<md.mesh.numberofvertices;i++) tpmp[i]= md.materials.meltingpoint - md.materials.beta*md.initialization.pressure[i];
+					enthalpy=NewArrayFill(md.mesh.numberofvertices,0); 
+					for (var i=0;i<md.mesh.numberofvertices;i++)enthalpy[i] = md.materials.heatcapacity*(md.initialization.temperature[i]-md.constants.referencetemperature);
+					for (var i=0;i<md.mesh.numberofvertices;i++)if(md.initialization.temperature[i]>=tpmp[i]){
+						enthalpy[i] = md.materials.heatcapacity*(tpmp[i] - md.constants.referencetemperature) + md.materials.latentheat*md.initialization.waterfraction[i];
+					}
+				} else {
+					enthalpy = this.enthalpy;
 				}
 				WriteData(fid,prefix,'data',enthalpy,'format','DoubleMat','mattype',1,'name','md.initialization.enthalpy');
@@ -136,15 +183,23 @@
 	//properties 
 	// {{{
-	this.vx            = NaN;
-	this.vy            = NaN;
-	this.vz            = NaN;
-	this.vel           = NaN;
-	this.pressure      = NaN;
-	this.temperature   = NaN;
-	this.waterfraction = NaN;
-	this.sediment_head = NaN;
-	this.epl_head      = NaN;
-	this.epl_thickness = NaN;
-	this.watercolumn   = NaN;
+	this.vx                  = NaN;
+	this.vy                  = NaN;
+	this.vz                  = NaN;
+	this.vel                 = NaN;
+	this.pressure            = NaN;
+	this.temperature         = NaN;
+	this.enthalpy            = NaN;
+	this.waterfraction       = NaN;
+	this.sediment_head       = NaN;
+	this.epl_head            = NaN;
+	this.epl_thickness       = NaN;
+	this.watercolumn         = NaN;
+	this.hydraulic_potential = NaN;
+	this.channelarea         = NaN;
+	this.sealevel            = NaN;
+	this.bottompressure      = NaN;
+	this.dsl                 = NaN;
+	this.str                 = NaN;
+	this.sample              = NaN;
 	this.setdefaultparameters();
 
Index: issm/trunk/src/m/classes/initialization.m
===================================================================
--- issm/trunk/src/m/classes/initialization.m	(revision 25994)
+++ issm/trunk/src/m/classes/initialization.m	(revision 26744)
@@ -20,22 +20,11 @@
 		hydraulic_potential = NaN;
 		channelarea         = NaN;
+		sealevel            = NaN;
+		bottompressure      = NaN;
+		dsl                 = NaN;
+		str                 = NaN;
+		sample              = NaN;
 	end
 	methods
-		function self = extrude(self,md) % {{{
-			self.vx=project3d(md,'vector',self.vx,'type','node');
-			self.vy=project3d(md,'vector',self.vy,'type','node');
-			self.vz=project3d(md,'vector',self.vz,'type','node');
-			self.vel=project3d(md,'vector',self.vel,'type','node');
-			self.temperature=project3d(md,'vector',self.temperature,'type','node');
-			self.enthalpy=project3d(md,'vector',self.enthalpy,'type','node');
-			self.waterfraction=project3d(md,'vector',self.waterfraction,'type','node');
-			self.watercolumn=project3d(md,'vector',self.watercolumn,'type','node','layer',1);
-			self.sediment_head=project3d(md,'vector',self.sediment_head,'type','node','layer',1);
-			self.epl_head=project3d(md,'vector',self.epl_head,'type','node','layer',1);
-			self.epl_thickness=project3d(md,'vector',self.epl_thickness,'type','node','layer',1);
-
-			%Lithostatic pressure by default
-			self.pressure=md.constants.g*md.materials.rho_ice*(md.geometry.surface-md.mesh.z);
-		end % }}}
 		function self = initialization(varargin) % {{{
 			switch nargin
@@ -47,5 +36,4 @@
 		end % }}}
 		function self = setdefaultparameters(self) % {{{
-
 		end % }}}
 		function md = checkconsistency(self,md,solution,analyses) % {{{
@@ -59,4 +47,11 @@
 				md = checkfield(md,'fieldname','initialization.vx','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices 1]);
 				md = checkfield(md,'fieldname','initialization.vy','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices 1]);
+			end
+			if ismember('OceantransportAnalysis',analyses) 
+				if strcmp(solution,'TransientSolution') & md.transient.isslc & md.transient.isoceantransport,
+					md = checkfield(md,'fieldname','initialization.bottompressure','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices 1]);
+					md = checkfield(md,'fieldname','initialization.dsl','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices 1]);
+					md = checkfield(md,'fieldname','initialization.str','NaN',1,'Inf',1,'size',[1 1]);
+				end
 			end
 			if ismember('BalancethicknessAnalysis',analyses) & strcmp(solution,'BalancethicknessSolution'),
@@ -88,5 +83,17 @@
 			if ismember('HydrologyShreveAnalysis',analyses),
 				if isa(md.hydrology,'hydrologyshreve'),
+					if (strcmp(solution,'TransientSolution') & md.transient.ishydrology) | strcmp(solution,'HydrologySolution'),
+						md = checkfield(md,'fieldname','initialization.watercolumn','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices 1]);
+					end
+				end
+			end
+			if ismember('HydrologyTwsAnalysis',analyses),
+				if isa(md.hydrology,'hydrologytws'),
 					md = checkfield(md,'fieldname','initialization.watercolumn','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices 1]);
+				end
+			end
+			if ismember('SealevelchangeAnalysis',analyses),
+				if strcmp(solution,'TransientSolution') & md.transient.isslc,
+					md = checkfield(md,'fieldname','initialization.sealevel','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices 1]);
 				end
 			end
@@ -109,4 +116,9 @@
 						md = checkfield(md,'fieldname','initialization.epl_thickness','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices 1]);
 					end
+				end
+			end
+			if ismember('SamplingAnalysis',analyses) & ~(strcmp(solution,'TransientSolution') & md.transient.issampling == 0),
+				if ~isnan(md.initialization.sample)
+					md = checkfield(md,'fieldname','initialization.sample','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices 1]);
 				end
 			end
@@ -129,5 +141,8 @@
 			fielddisplay(self,'hydraulic_potential','Hydraulic potential (for GlaDS) [Pa]');
 			fielddisplay(self,'channelarea','subglacial water channel area (for GlaDS) [m2]');
-
+			fielddisplay(self,'sample','Realization of a Gaussian random field');
+			fielddisplay(self,'bottompressure','Bottom pressures');
+			fielddisplay(self,'dsl','Dynamic sea level.');
+			fielddisplay(self,'str','Steric sea level.');
 		end % }}}
 		function marshall(self,prefix,md,fid) % {{{
@@ -139,4 +154,8 @@
 			WriteData(fid,prefix,'object',self,'fieldname','vz','format','DoubleMat','mattype',1,'scale',1./yts);
 			WriteData(fid,prefix,'object',self,'fieldname','pressure','format','DoubleMat','mattype',1);
+			WriteData(fid,prefix,'object',self,'fieldname','sealevel','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+			WriteData(fid,prefix,'object',self,'fieldname','bottompressure','format','DoubleMat','mattype',1);
+			WriteData(fid,prefix,'object',self,'fieldname','str','format','DoubleMat','mattype',1);
+			WriteData(fid,prefix,'object',self,'fieldname','dsl','format','DoubleMat','mattype',1);
 			WriteData(fid,prefix,'object',self,'fieldname','temperature','format','DoubleMat','mattype',1);
 			WriteData(fid,prefix,'object',self,'fieldname','waterfraction','format','DoubleMat','mattype',1);
@@ -147,4 +166,5 @@
 			WriteData(fid,prefix,'object',self,'fieldname','channelarea','format','DoubleMat','mattype',1);
 			WriteData(fid,prefix,'object',self,'fieldname','hydraulic_potential','format','DoubleMat','mattype',1);
+			WriteData(fid,prefix,'object',self,'fieldname','sample','format','DoubleMat','mattype',1);
 
 			if md.thermal.isenthalpy,
@@ -161,6 +181,26 @@
 			end
 		end % }}}
+		function self = extrude(self,md) % {{{
+			self.vx=project3d(md,'vector',self.vx,'type','node');
+			self.vy=project3d(md,'vector',self.vy,'type','node');
+			self.vz=project3d(md,'vector',self.vz,'type','node');
+			self.vel=project3d(md,'vector',self.vel,'type','node');
+			self.temperature=project3d(md,'vector',self.temperature,'type','node');
+			self.enthalpy=project3d(md,'vector',self.enthalpy,'type','node');
+			self.waterfraction=project3d(md,'vector',self.waterfraction,'type','node');
+			self.watercolumn=project3d(md,'vector',self.watercolumn,'type','node','layer',1);
+			self.sediment_head=project3d(md,'vector',self.sediment_head,'type','node','layer',1);
+			self.epl_head=project3d(md,'vector',self.epl_head,'type','node','layer',1);
+			self.epl_thickness=project3d(md,'vector',self.epl_thickness,'type','node','layer',1);
+			self.sealevel=project3d(md,'vector',self.sealevel,'type','node','layer',1);
+			self.bottompressure=project3d(md,'vector',self.bottompressure,'type','node','layer',1);
+			self.dsl=project3d(md,'vector',self.dsl,'type','node','layer',1);
+			self.str=project3d(md,'vector',self.str,'type','node','layer',1);
+
+			%Lithostatic pressure by default
+			self.pressure=md.constants.g*md.materials.rho_ice*(md.geometry.surface-md.mesh.z);
+		end % }}}
 		function savemodeljs(self,fid,modelname) % {{{
-		
+
 			writejs1Darray(fid,[modelname '.initialization.vx'],self.vx);
 			writejs1Darray(fid,[modelname '.initialization.vy'],self.vy);
@@ -177,4 +217,5 @@
 			writejs1Darray(fid,[modelname '.initialization.hydraulic_potential'],self.hydraulic_potential);
 			writejs1Darray(fid,[modelname '.initialization.channel'],self.channelarea);
+			writejs1Darray(fid,[modelname '.initialization.sample'],self.sample);
 
 		end % }}}
